/* AmbitDatabaseFormat.java
 * Author: Nina Jeliazkova
 * Date: 2006-7-1 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package ambit.database;

import org.openscience.cdk.io.formats.IResourceFormat;

/**
 * An implementation of {@link org.openscience.cdk.io.formats.IResourceFormat} to be used in database readers 
 * {@link ambit.database.readers} , {@link ambit.database.search}.
 * @author Nina Jeliazkova nina@acad.bg
 * <b>Modified</b> 2006-7-1
 */
public class AmbitDatabaseFormat implements IResourceFormat {
    protected static final String name = "Ambit database";
    /**
     * 
     */
    public AmbitDatabaseFormat() {
        super();
    }

    /* (non-Javadoc)
     * @see org.openscience.cdk.io.formats.IResourceFormat#getFormatName()
     */
    public String getFormatName() {
        return name;
    }

    /* (non-Javadoc)
     * @see org.openscience.cdk.io.formats.IResourceFormat#getPreferredNameExtension()
     */
    public String getPreferredNameExtension() {
        return null;
    }

    /* (non-Javadoc)
     * @see org.openscience.cdk.io.formats.IResourceFormat#getNameExtensions()
     */
    public String[] getNameExtensions() {
        return null;
    }

    /* (non-Javadoc)
     * @see org.openscience.cdk.io.formats.IResourceFormat#getMIMEType()
     */
    public String getMIMEType() {
        // TODO Auto-generated method stub
        return null;
    }

    /* (non-Javadoc)
     * @see org.openscience.cdk.io.formats.IResourceFormat#isXMLBased()
     */
    public boolean isXMLBased() {
        return false;
    }

}
