package ambit.ui.data.molecule;

import java.awt.Dimension;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;

import org.openscience.cdk.Molecule;
import org.openscience.cdk.interfaces.IAtomContainer;
import org.openscience.cdk.interfaces.ISetOfAtomContainers;

import toxTree.query.MolFlags;
import ambit.data.experiment.ExperimentList;
import ambit.data.molecule.Compound;
import ambit.data.molecule.CompoundsList;
import ambit.data.molecule.DataContainer;
import ambit.misc.AmbitCONSTANTS;
import ambit.ui.EditorPanel;
import ambit.ui.data.AmbitListEditor;
import ambit.ui.data.CompoundsGridPane;

public class ToolboxDetailsPanel extends JTabbedPane implements Observer {
	//AquirePanel aquirePanel ;
	AmbitListEditor editor;
	EditorPanel editorPanel;
	CompoundsGridPane metabolitesPanel;
	CompoundsList metabolites;
	public ToolboxDetailsPanel() {
		super();
		addWidgets();
	}

	public ToolboxDetailsPanel(int arg0) {
		super(arg0);
		addWidgets();
	}

	public ToolboxDetailsPanel(int arg0, int arg1) {
		super(arg0, arg1);
		addWidgets();
	}
	public void addWidgets() {
		metabolites = new CompoundsList();
		editorPanel = new EditorPanel();
        editorPanel.setPreferredSize(new Dimension(100,150));
        addTab("Experimental data",editorPanel);
        metabolitesPanel = new CompoundsGridPane(metabolites,3,new Dimension(150,150));
        addTab("Metabolites",metabolitesPanel);
        setPreferredSize(new Dimension(200,100));
	}
	/* (non-Javadoc)
	 * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
	 */
	public void update(Observable o, Object arg) {
		if (o == null) return;
	    if (o instanceof DataContainer) {
	        IAtomContainer m = ((DataContainer) o).getMolecule();
	        if (m == null) return;
	        Object a = m.getProperty(AmbitCONSTANTS.AQUIRE);
	        if (a ==null)
	        	a = m.getProperty(AmbitCONSTANTS.EXPERIMENT_LIST);
	        if (a != null) {
	        	setSelectedIndex(0);
	        	if (a instanceof ExperimentList) {
		        	if (editor == null) {
		        		editor  = new AmbitListEditor((ExperimentList)a,JSplitPane.HORIZONTAL_SPLIT,false);
		        		editorPanel.setEditor(editor);
		        	} else 
		        		editor.setAmbitList((ExperimentList)a);
	        	    	
	        	}    

	        } else if (editor != null) editor.setAmbitList(null);
	        
	        a = m.getProperty(MolFlags.MOLFLAGS);
	        metabolites.clear();
	        if ((a != null) && (a instanceof MolFlags)) {
	        	setSelectedIndex(1);
	        	
			    MolFlags mf = (MolFlags) a;
			    
			    ISetOfAtomContainers sc = mf.getHydrolysisProducts();
			    if (sc != null) {
			    	setSelectedIndex(1);
				    StringBuffer b = new StringBuffer();
				    for (int i=0; i < sc.getAtomContainerCount();i++) { 
				    	metabolites.addItem(new Compound((Molecule)sc.getAtomContainer(i)));
				    }	
				    
				    return;
			    } ;
	        } ;
	    }
	
	}

}
