/*
Copyright Ideaconsult Ltd. (C) 2005-2007  

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
package chemCast.data;

import ambit.ui.data.RandomAccessFileTableModel;
import chemCast.exception.SubsetException;
import chemCast.similarity.data.Subset;

public class RandomAccessSubsetTableModel extends RandomAccessFileTableModel {
	protected Subset subset;
	/**
	 * 
	 */
	private static final long serialVersionUID = 6212392123177048515L;

	public RandomAccessSubsetTableModel() throws SubsetException {
		// TODO Auto-generated constructor stub
	}

	public RandomAccessSubsetTableModel(Subset subset)  {
		super();
		try {
			setSubset(subset);
        } catch (SubsetException x) {
            this.subset = null;
            this.reader = null;
        }

	}
    public synchronized void setSubset(Subset subset) throws SubsetException {
        System.out.println(subset);
        //if (this.subset != subset) {
            System.out.println("set");
            this.subset = subset;
            if (subset == null) super.setReader(null);
            else {
                super.setReader(subset.getData());
                System.out.println("#"+ subset.getData().getAtomContainerCount());
            }
            fireTableStructureChanged();
        //}
    }
    @Override
    public boolean isCellEditable(int row, int col) {
    	return (subset!= null) 
            && ((col==1) || !subset.isReadOnly());
    }
    public Subset getSubset() {
    	return subset;
    }
}


