/* SelectedItem.java
 * Author: Nina Jeliazkova
 * Date: Sep 30, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.data;

import org.openscience.cdk.interfaces.IAtomContainer;

import chemCast.similarity.data.Subset;
import chemCast.similarity.data.Subsets;

public class SelectedItem {
	protected Subsets dataset;
    protected Subset subset;
    protected int item;
    public SelectedItem(Subsets dataset, Subset subset, int item) {
        this.dataset = dataset;
        this.subset = subset;
        this.item = item;
    }
    @Override
    public boolean equals(Object obj) {
        SelectedItem selected = (SelectedItem) obj;
        return (selected.dataset == dataset) && 
        (selected.subset == subset) && (selected.item == item);
    }
    public synchronized int getIndex() {
        return item;
    }
    public synchronized void setIndex(int index) {
        this.item = index;
    }
    public synchronized Subset getSubset() {
        return subset;
    }
    public synchronized void setSubset(Subset subset) {
        this.subset = subset;
    }
    public IAtomContainer getAtomContainer() throws Exception {
        if (subset == null) return null;
        return subset.getData().getAtomContainer(item);
        
    }
    @Override
    public String toString() {
        if (subset == null) return "";
        return subset.toString() + " #" + item;
    }
	public synchronized Subsets getDataset() {
		return dataset;
	}
	public synchronized void setDataset(Subsets dataset) {
		this.dataset = dataset;
	}
}
