/* SimilarityDefs.java
 * Author: Nina Jeliazkova
 * Date: Sep 23, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.similarity.data;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class SimilarityDefs extends ChemCastObject implements
        IChemCastList {
    public static String p_similarityMethods="similarityMethods";
    protected List list;
    
    public SimilarityDefs() {
        super();
        list = createList();
    }
    
    protected List<? extends SimilarityDef> createList() {
        return new ArrayList<SimilarityDef>();
    }
    
    public SimilarityDefs(Element element) throws Exception {
        this();
        setXMLElement(element);
    }
    @Override
    public Element getXMLElement(Document document) {
        return ChemCastObjectFactory.getXMLElement(list, document, p_similarityMethods);
    }
    public int indexOf(SimilarityDef similarity) {
    	return list.indexOf(similarity);
    }

    @Override
    public void setXMLElement(Element element) throws Exception {
        if (element.getNodeName().equals(p_similarityMethods)) {
            NodeList nodes = element.getElementsByTagName(SimilarityDef.p_similarity);
            for (int i=0; i < nodes.getLength(); i++) {
                SimilarityDef s = new SimilarityDef((Element)nodes.item(i));
                add(s);
            }
        }
    }
    public void add(SimilarityDef subset) {
        firePropertyChange("add", null, subset);
        list.add(subset);
    }
  
    public void remove(SimilarityDef subset) {
        firePropertyChange("remove", subset, null);
        list.remove(subset);
    }
    public SimilarityDef get(int i) {
    	return (SimilarityDef) list.get(i);
    }
    public void clear() {
        list.clear();
        super.clear();
    }
    public int compareTo(Object o) {
        // TODO Auto-generated method stub
        return 0;
    }
    public List <? extends IChemCastObject> getList() {
        return list;
    }
    public String toString() {
        return "Similarity methods"; //ChemCastObjectFactory.toString(options);
    }
    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Subsets) {
            return list.equals(((Subsets) obj).getList());
        } return super.equals(obj);
    }

    public void selectAll(boolean selected) {
    }
}
