/* BigTableTest.java
 * Author: Nina Jeliazkova
 * Date: 2006-7-5 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.test;

import java.awt.Color;
import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.border.Border;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;

import junit.framework.TestCase;
import chemCast.ui.SelectionListener;
import chemCast.ui.SimilarityMatrixPanel;

/**
 * TODO add description
 * @author Nina Jeliazkova nina@acad.bg
 * <b>Modified</b> 2006-7-5
 */
public class BigTableTest extends TestCase {
	
    public static void main(String[] args) {
        junit.textui.TestRunner.run(BigTableTest.class);
    }
    public void test() {
    	SimilarityMatrixPanel p = new SimilarityMatrixPanel();
    	p.setModel(new BigTableModel());
    	p.addListSelectionListener(new SelectionListener(p.getTable()) {
    		public void getColumnSelected(JTable table, int column) {
    			System.out.println("column "+column);
    		};
    		public void getRowSelected(JTable table, int row) {
    			System.out.println("row "+row);
    		};
    	});
    	/*
        JTable table = new JTable();
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF); 
        table.setRowHeight(8);
        table.setShowGrid(true);
        table.setGridColor(Color.white);
        table.setColumnModel(new BigTableColumnModel(table));
        table.setSurrendersFocusOnKeystroke(true);
        //table.setPreferredScrollableViewportSize(new Dimension(600,200));
        table.setRowSelectionAllowed(true);
        table.setColumnSelectionAllowed(true);
        //table.ro
        //table.setPreferredSize(new Dimension(32*100,200));
        //table.setMaximumSize(new Dimension(400,200));
        JScrollPane p = new JScrollPane(table);
        
        //p.setAutoscrolls(true);
        //p.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        //p.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        p.setPreferredSize(new Dimension(600,400));
        //p.setPreferredSize(new Dimension(1000,800));
        p.setMaximumSize(new Dimension(1000,800));
        */
        JOptionPane.showMessageDialog(null,p,"Test",JOptionPane.PLAIN_MESSAGE);
    }
}
class BigTableColumnModel extends DefaultTableColumnModel {
	final int cellSize = 8;
    public BigTableColumnModel(JTable table) {
        super();
        TableCellRenderer r = new DefaultTableCellRenderer() {
            Border b = BorderFactory.createMatteBorder(1,1,0,0,Color.white);
            Border sb = BorderFactory.createMatteBorder(2,2,2,2,Color.blue);
            /* (non-Javadoc)
             * @see javax.swing.table.DefaultTableCellRenderer#getTableCellRendererComponent(javax.swing.JTable, java.lang.Object, boolean, boolean, int, int)
             */
            public Component getTableCellRendererComponent(JTable table,
                    Object value, boolean isSelected, boolean hasFocus,
                    int row, int column) {
                // TODO Auto-generated method stub
                Component c = super.getTableCellRendererComponent(table, value,
                        isSelected, hasFocus, row, column);
                double d = ((Double) value).doubleValue();
                System.out.println(d);
                setBackground(new Color(Color.HSBtoRGB((float)d*180, (float)180.0,(float)180.0)));
                //setBackground(new Color((int) (column%255) ,(int) (row*column%255),(int) (row*column%255)));
                if (isSelected)
                    setBorder(sb);
                else
                    setBorder(b);
                return c;
            }
        };
        for (int i=0; i < table.getColumnCount();i++) {
            TableColumn c = new TableColumn(i);
            c.setMinWidth(cellSize);
            c.setMaxWidth(cellSize);
            c.setHeaderValue(new Integer(i));
            c.setPreferredWidth(cellSize);
            c.setCellRenderer(r);
            addColumn(c);
        }
    }
}
class BigTableModel extends AbstractTableModel {
    /**
     * 
     */
    private static final long serialVersionUID = 7834677405812254425L;
    /* (non-Javadoc)
     * @see javax.swing.table.TableModel#getColumnCount()
     */
    public int getColumnCount() {
        return 10000;
    }
    /* (non-Javadoc)
     * @see javax.swing.table.TableModel#getRowCount()
     */
    public int getRowCount() {
        return 10000;
    }
    /* (non-Javadoc)
     * @see javax.swing.table.TableModel#getValueAt(int, int)
     */
    public Object getValueAt(int rowIndex, int columnIndex) {
        return new Double(rowIndex/100.0);
    }
    /* (non-Javadoc)
     * @see javax.swing.table.AbstractTableModel#getColumnName(int)
     */
    public String getColumnName(int column) {
        return Integer.toString(column);
    }
    /* (non-Javadoc)
     * @see javax.swing.table.AbstractTableModel#isCellEditable(int, int)
     */
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return true;
    }
}