/* ConfigTest.java
 * Author: Nina Jeliazkova
 * Date: Sep 22, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.test;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import junit.framework.TestCase;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import chemCast.similarity.data.Endpoints;
import chemCast.similarity.data.IChemCastObject;
import chemCast.similarity.data.Subsets;
import chemCast.ui.wizard.EndpointsWizard;

public class ConfigTest extends TestCase {
    public void test() {
        File file = new File("ChemCAST_default.xml");
        
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setNamespaceAware(false);
        try {
            DocumentBuilder builder = factory.newDocumentBuilder();
            Document doc = builder.parse(file);
            NodeList nodes = doc.getElementsByTagName(Endpoints.p_endpoints);
            Endpoints e = new Endpoints((Element)nodes.item(0));
            assertTrue(e.getList().size() > 0);
            System.out.println(e);
            createWizard(e);
            for (int i=0; i < e.getList().size();i++) {
                System.out.print("Name " +e.get(i).getName());
                System.out.println(" Source " + e.get(i).getTrainingData().getDatasetValue());
                assertTrue(new File(e.get(i).getTrainingData().getDatasetValue()).exists());
            }    
            
            
        } catch (Exception x) {
            x.printStackTrace();
            fail();
        }
    }
    
    public void createWizard(Endpoints endpoints) {
        final Subsets subsets = new Subsets();
        List<Subsets> l = new ArrayList<Subsets>();
        l.add(subsets);
        EndpointsWizard wizard = new EndpointsWizard(null,endpoints,l,0);
        wizard.getDialog().setTitle("Test Wizard Dialog");
        
        int ret = wizard.showModalDialog();
        
        System.out.println("Dialog return code is (0=Finish,1=Cancel,2=Error): " + ret);
        System.out.println(wizard.getEndpoint());
        Subsets sets = wizard.getSubset();
        System.out.println(sets);
        List<? extends IChemCastObject> list = sets.getList();
        for (int i=0; i < list.size();i++)
            if (list.get(i).isEnabled())
                System.out.println(list.get(i));
        
        //System.exit(0);
    }
}
