/* EndpointTest.java
 * Author: Nina Jeliazkova
 * Date: Sep 23, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.test.data;

import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import junit.framework.TestCase;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import chemCast.similarity.data.ChemCastObjectFactory;
import chemCast.similarity.data.DatasetDef;
import chemCast.similarity.data.Endpoint;
import chemCast.similarity.data.Endpoints;
import chemCast.similarity.data.SimilarityDef;
import chemCast.similarity.data.SimilarityDefs;
import chemCast.similarity.data.Subset;
import chemCast.similarity.data.Subsets;

/**
 * TODO add description
 * @author Nina Jeliazkova nina@acad.bg
 * <b>Modified</b> Sep 23, 2006
 */
public class EndpointTest extends TestCase {

    /**
     * @param arg0
     */
    public EndpointTest(String arg0) {
        super(arg0);
    }

    /* (non-Javadoc)
     * @see junit.framework.TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
    }

    /* (non-Javadoc)
     * @see junit.framework.TestCase#tearDown()
     */
    protected void tearDown() throws Exception {
        super.tearDown();
    }

    public void test() {
        try {
            SimilarityDefs s = new SimilarityDefs();
            s.add(new SimilarityDef());
            Subsets sets = new Subsets();
            sets.add(new Subset());
            List<Subsets> l = new ArrayList<Subsets>();
            l.add(sets);
            DatasetDef ds = new DatasetDef();
            ds.getProperties().getIdentifiers().put("CAS", "CASRN");
            ds.getProperties().getDescriptorProperties().put("Descriptor", "Descriptor1");
            
        	Endpoint d = new Endpoint("name",ds,s,l);
            assertEquals("name", d.getName());
            assertEquals(new DatasetDef(), d.getTrainingData());
            assertEquals(1, d.getSimilarityMethods().getList().size());
            assertEquals(1, d.getSubsets().get(0).size());
            DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
            Document doc = builder.newDocument();
            Element e = d.getXMLElement(doc);
            doc.appendChild(e);
            ChemCastObjectFactory.writeXmlFile(doc, "endpoints.xml");
            Endpoint d1 = new Endpoint((Element)doc.getChildNodes().item(0));
            
            
            assertEquals(ds, d1.getTrainingData());
            assertEquals(ds.getProperties().getDescriptorProperties(), d1.getTrainingData().getProperties().getDescriptorProperties());
            
            Document doc1 = builder.newDocument();
            doc1.appendChild(d1.getXMLElement(doc1));
            ChemCastObjectFactory.writeXmlFile(doc1, "endpoints1.xml");

            assertEquals(1,d1.getSubsets().size());
        } catch (Exception x) {
            x.printStackTrace();
            fail();
        }
        
    }
    
    public void testlistToXML() {
    
        try {
            SimilarityDefs s = new SimilarityDefs();
            s.add(new SimilarityDef());
            Subsets sets = new Subsets();
            sets.add(new Subset());
            List<Subsets> l = new ArrayList<Subsets>();
            l.add(sets);
            Endpoint d = new Endpoint("name",new DatasetDef(),s,l);
            Endpoints e = new Endpoints();
            e.add(d);
            DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
            Document doc = builder.newDocument();
            doc.appendChild(e.getXMLElement(doc));
            
            NodeList nodes = doc.getElementsByTagName(Endpoints.p_endpoints);
            Endpoints endpoints = new Endpoints((Element)nodes.item(0));
            assertEquals(1,endpoints.getList().size());
        } catch (Exception x) {
            x.printStackTrace();
            fail();
        }
    }
    

}
