/*
Copyright (C) 2005-2006  

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation; either version 2.1
of the License, or (at your option) any later version.
All we ask is that proper credit is given for our work, which includes
- but is not limited to - adding the above copyright notice to the beginning
of your source code files, and to any copyright notice that you may distribute
with programs based on this work.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*/

package chemCast.test.weka;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Enumeration;

import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import chemCast.weka.WekaClustering;

import junit.framework.TestCase;
import weka.attributeSelection.AttributeEvaluator;
import weka.attributeSelection.ChiSquaredAttributeEval;
import weka.attributeSelection.InfoGainAttributeEval;
import weka.attributeSelection.OneRAttributeEval;
import weka.attributeSelection.PrincipalComponents;
import weka.attributeSelection.ReliefFAttributeEval;
import weka.attributeSelection.SVMAttributeEval;
import weka.attributeSelection.SymmetricalUncertAttributeEval;
import weka.clusterers.Clusterer;
import weka.clusterers.SimpleKMeans;
import weka.core.Attribute;
import weka.core.FastVector;
import weka.core.Instance;
import weka.core.Instances;
import weka.gui.AttributeSummaryPanel;
import weka.gui.AttributeVisualizationPanel;
import weka.gui.GenericObjectEditor;
import weka.gui.PropertyPanel;
import weka.gui.ViewerDialog;
import weka.gui.explorer.AttributeSelectionPanel;
import weka.gui.explorer.PreprocessPanel;
import weka.gui.visualize.MatrixPanel;

public class WekaTest extends TestCase {

	public static void main(String[] args) {
		junit.textui.TestRunner.run(WekaTest.class);
	}
	public void test() {
		FastVector attributes = new FastVector();
		
		int n = 10;
		for (int i=0; i < n; i++ )
			attributes.addElement(new Attribute("X"+Integer.toString(i+1)));
		attributes.addElement(new Attribute("Y"));
		double[] d = new double[n+1];
		Instance instance = new Instance(1,d);
		int dd = 40;
		Instances instances = new Instances("test",attributes,dd);
		for (int i=0; i < dd; i++) {
			for (int j=0; j < d.length;j++) { 
				instance.setValue(j, j+Math.random());
			}
			instances.add(instance);
		}	
        
        JPanel p = new JPanel(new BorderLayout());
        
        AttributeVisualizationPanel p1 = new AttributeVisualizationPanel();
        p1.setPreferredSize(new Dimension(200,200));
        AttributeSummaryPanel p2 = new AttributeSummaryPanel();
        AttributeSelectionPanel p3 = new AttributeSelectionPanel();
        p.add(p1,BorderLayout.WEST);p.add(p2,BorderLayout.EAST);
        p.add(p3,BorderLayout.CENTER);
        p1.setInstances(instances);p2.setInstances(instances);p3.setInstances(instances);
        p1.setAttribute(0);p2.setAttribute(0);
        JOptionPane.showMessageDialog(null,p);
        
        ViewerDialog dlg = new ViewerDialog(null);
        dlg.setInstances(instances);
        dlg.showDialog();
        /*
		System.out.println(instances.toString());
		System.out.println();
		System.out.println(instances.toSummaryString());
		System.out.println();
		*/
//        Classifier tree = new J48();
  //      instances.setClassIndex(n);
		SimpleKMeans kMeans = new SimpleKMeans();
		
		
		//Clusterer clusterer = new MakeDensityBasedClusterer();
		try {
			/*
			AddCluster filter = new AddCluster();
			String[] options = new String[] {"-W","weka.clusterers.SimpleKMeans -N 3"};
			filter.setOptions(options);

			filter.setInputFormat(instances);
			Instances newInstances = Filter.useFilter(instances, filter);
			*/
			
			kMeans.setOptions(new String[]{"-N","3"});    
			kMeans.buildClusterer(instances);
			System.out.println(kMeans.toString());
			Enumeration e = instances.enumerateInstances();
			
			while (e.hasMoreElements()){
				Instance in = (Instance)e.nextElement();
				d = kMeans.distributionForInstance(in);
				System.out.println(kMeans.clusterInstance(in));
				
				for (int i=0; i < d.length;i++) {
					System.out.print(d[i]);
					System.out.print('\t');
				}
				System.out.println();
			}
            GenericObjectEditor m_ClustererEditor =  new GenericObjectEditor();
            m_ClustererEditor.setClassType(Clusterer.class);
            m_ClustererEditor.setValue(kMeans);
            m_ClustererEditor.addPropertyChangeListener(new PropertyChangeListener() {
              public void propertyChange(PropertyChangeEvent e) {
                  ((JComponent)e.getSource()).repaint();
              }
            });
            JOptionPane.showMessageDialog(null,m_ClustererEditor.getCustomEditor(),"test",JOptionPane.OK_OPTION,null);
            System.out.println(kMeans.getNumClusters());

			 
			
			JTabbedPane m_TabbedPane = new JTabbedPane();
			PreprocessPanel m_PreprocessPanel = new PreprocessPanel();
			/*
			m_PreprocessPanel.addPropertyChangeListener(new PropertyChangeListener() {
			      public void propertyChange(PropertyChangeEvent e) {
			        m_ClassifierPanel.setInstances(m_PreprocessPanel.getInstances());
			        m_AssociationPanel.setInstances(m_PreprocessPanel.getInstances());
			        m_ClustererPanel.setInstances(m_PreprocessPanel.getInstances());
			        m_AttributeSelectionPanel.setInstances(m_PreprocessPanel
			                                               .getInstances());
			        m_VisualizePanel.setInstances(m_PreprocessPanel.getInstances());
			        
			        m_TabbedPane.setEnabledAt(1, true);
			        m_TabbedPane.setEnabledAt(2, true);
			        m_TabbedPane.setEnabledAt(3, true);
			        m_TabbedPane.setEnabledAt(4, true);
			        m_TabbedPane.setEnabledAt(5, true);
			      }
			    });
			    */
			AttributeSelectionPanel m_AttributeSelectionPanel =   new AttributeSelectionPanel();
			m_AttributeSelectionPanel.setInstances(instances);
			MatrixPanel m_VisualizePanel = new MatrixPanel();
			m_PreprocessPanel.setPreferredSize(new Dimension(600,600));
			m_VisualizePanel.setPreferredSize(new Dimension(600,600));
			m_PreprocessPanel.setInstances(instances);
			m_VisualizePanel.setInstances(instances);
			/*
			InstanceTable instance_table = new InstanceTable();
			instance_table
			*/
			m_TabbedPane.addTab("Preprocess", null, m_PreprocessPanel,"Open/Edit/Save instances");
			m_TabbedPane.addTab("Visualize", null, m_VisualizePanel,    "Explore the data");
			m_TabbedPane.addTab("Select attributes", null, m_AttributeSelectionPanel,
		      "Determine relevance of attributes");
			
			JOptionPane.showMessageDialog(null,m_TabbedPane,"test",JOptionPane.OK_OPTION,null);
			
		} catch (Exception x) {
			x.printStackTrace();
			fail();
		}
	}
	public void testAttributeSelection() {
		FastVector attributes = new FastVector();
		
		int n = 100;
		for (int i=0; i < n; i++ )
			attributes.addElement(new Attribute("X"+Integer.toString(i+1)));
		//attributes.addElement(new Attribute("Y"));
		
		FastVector fvClassVal = new FastVector(2);
		fvClassVal.addElement("0");
		fvClassVal.addElement("1");
		attributes.addElement(new Attribute("theClass", fvClassVal));
		
		double[] d = new double[n+1];
		Instance instance = new Instance(1,d);
		int dd = 2000;
		Instances instances = new Instances("test",attributes,dd);
		instances.setClassIndex(n);
		for (int i=0; i < dd; i++) {
			for (int j=0; j < d.length-1;j++) { 
				instance.setValue(j, j+Math.random());
			}
			//instance.setValue(n, Math.random());
			instance.setDataset(instances);
			instance.setClassValue(fvClassVal.elementAt(i%2).toString());
			instances.add(instance);
			
		}	
		
		System.out.println(instances);
		
		AttributeEvaluator[] evaluator = new AttributeEvaluator[7]; 
		evaluator[0] = new ReliefFAttributeEval();
		evaluator[1] = new PrincipalComponents();
		evaluator[2] = new ChiSquaredAttributeEval();
		evaluator[3] = new InfoGainAttributeEval();
		evaluator[4] = new OneRAttributeEval();
		evaluator[5] = new SVMAttributeEval();
		evaluator[6] = new SymmetricalUncertAttributeEval();
		
		for (int e=0; e< evaluator.length;e++)
			try {
				System.out.println(evaluator[e].getClass().getName());
				evaluator[e].buildEvaluator(instances);
				
				for (int i=0; i < n; i++ ) {
					System.out.print(i);
					System.out.print('\t');
					System.out.println(evaluator[e].evaluateAttribute(i));
				}	
			} catch (Exception x) {
				
				System.out.println(x.getMessage());
				//x.printStackTrace();
				//fail();
			}
	}
    public void testClusterer() {
        WekaClustering c = new WekaClustering();
        try {
            c.getEditor().view(null, false,"");
        } catch (Exception x) {
            
        }
    }
}


