/* EndpointsWizard.java
 * Author: Nina Jeliazkova
 * Date: Sep 23, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.ui.wizard;

import java.awt.Container;
import java.awt.event.ActionEvent;
import java.util.List;

import javax.swing.JScrollPane;

import chemCast.similarity.data.Endpoint;
import chemCast.similarity.data.Endpoints;
import chemCast.similarity.data.Subsets;
import chemCast.ui.ListsPanel;
import chemCast.ui.RadioBoxPanel;

import com.nexes.wizard.WizardPanelDescriptor;

public class EndpointsWizard extends WizardWrapper {
    protected Endpoints endpoints;
    protected List<Subsets> subsets;
    RadioBoxPanel endpointsPanel;
    ListsPanel subsetsPanel;
    ChemCastWizardPanelDescriptor descriptor1;
    ChemCastWizardPanelDescriptor descriptor2;
    public EndpointsWizard(Container owner, Endpoints endpoints,List<Subsets> subsets, int selected) {
        super(owner);
        this.endpoints = endpoints;
        this.subsets = subsets;
        createPanels(selected);
    }
    /*
    public void center(Component owner) {
        Dimension dim = owner.getToolkit().getScreenSize();
        Rectangle abounds = owner.getBounds();
        
        setLocation((dim.width - abounds.width) / 2,
              (dim.height - abounds.height) / 2);
    }
    */
    protected void createPanels(int selected) {
        endpointsPanel = new RadioBoxPanel("Endpoints",endpoints.getList(),selected){
            @Override
            public void selectObject(ActionEvent e, Object object) {
                if (object instanceof Endpoint) {
                    descriptor1.setNextId("subsets");
                    subsetsPanel.setCaption(((Endpoint) object).toString());
                    subsetsPanel.setLists(((Endpoint) object).getSubsets());
                }
            }
        };
        subsetsPanel = new ListsPanel("Groups",subsets);

        descriptor1 = new ChemCastWizardPanelDescriptor("endpoints","subsets",null,new JScrollPane(endpointsPanel),null);
        registerWizardPanel(descriptor1.getId().toString(), descriptor1);

        descriptor2 = new ChemCastWizardPanelDescriptor("subsets",WizardPanelDescriptor.FINISH,"endpoints",subsetsPanel,null);
        registerWizardPanel(descriptor2.getId().toString(), descriptor2);
        
        setCurrentPanel(descriptor1.getId().toString());
        endpointsPanel.selectObject(null, endpoints.getList().get(0)); 
    }
    public Endpoint getEndpoint() {
        
        int i = endpointsPanel.getSelectedIndex();
        if (i >= 0) return endpoints.get(i);
        else return null;
        
    }
    public Subsets getSubset() {
        try {
            return (Subsets)subsetsPanel.getSelectedItem();
        } catch (Exception x) {
            return null;
        }

        
    }
}
