/*
Copyright Ideaconsult Ltd. (C) 2005-2007 

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
All we ask is that proper credit is given for our work, which includes
- but is not limited to - adding the above copyright notice to the beginning
of your source code files, and to any copyright notice that you may distribute
with programs based on this work.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
package toxTree.test.tree.cramer;

import junit.framework.TestCase;

import org.openscience.cdk.Molecule;

import toxTree.core.IDecisionRule;
import toxTree.exceptions.DecisionMethodException;
import toxTree.exceptions.MolAnalyseException;
import toxTree.logging.TTLogger;
import toxTree.query.FunctionalGroups;
import toxTree.query.MolAnalyser;
import toxTree.tree.cramer.Rule32;

public class Rule32Test extends TestCase {
	public Rule32Test() {
		super();
		TTLogger.configureLog4j(true);
	}
	public void testRule32() {
	    IDecisionRule rule32 = new Rule32();

	    //
	    Object[][] answer = {
	            	{"CSC1=CC=CC=C1",new Boolean(false)},
	            	{"CC(C)CCC(=O)C1=CC=CC=C1",new Boolean(true)},
	    };
	      //      	{"OCCOC1=CC=CC=C1",new Boolean(false)} ,
	            
        
	    for (int i = 0; i < answer.length; i++) {
	    	Molecule mol = (Molecule)FunctionalGroups.createAtomContainer((String)answer[i][0]);
	    	
	        if (mol != null)
	            try {
	            	MolAnalyser.analyse(mol);
	                Boolean b = (Boolean) answer[i][1];
	                
	                boolean r = rule32.verifyRule(mol);
	                System.out.print(answer[i][0]);
	                assertEquals(b.booleanValue(),r);
	                System.out.println("\tOK");	                
	            } catch (DecisionMethodException x) {
	                x.printStackTrace();
	            } catch (MolAnalyseException x) {
	                x.printStackTrace();
	            }
	    }
	    
	}	
	
	
}
